-- add_printer("/account.php", function()
-- 	table = [[
-- 	<table  width=95%%  cellspacing=0 cellpadding=0>
-- 		<tr><td style="color: white;" align=center bgcolor=green><b>Kolproxy Options</b></td></tr>
-- 		<tr><td style="padding: 5px; border: 1px solid green;">
-- 			<center><table><tr><td>
-- 				<p><a href="custom-settings?pwd=]] .. session.pwd .. [[">Go to kolproxy settings</a></p>
-- 			</td></tr></table></center>
-- 		</td></tr>
-- 		<tr><td height=4></td></tr>
-- 	</table>
-- 	]]
-- 	text = string.gsub(text, [[<span id="ro">]], "\n" .. table .. "%0")
-- end)

-- function make_buttons(valuestr, value, options)
-- 	buttons = ""
-- 	for _, v in ipairs(options) do
-- 		if value == v.value then
-- 			buttons = buttons .. [[<input type="radio" name="]]..valuestr..[[" value="]] .. v.value .. [[" checked="yes">]] .. v.text
-- 		else
-- 			buttons = buttons .. [[<input type="radio" name="]]..valuestr..[[" value="]] .. v.value .. [[">]] .. v.text
-- 		end
-- 	end
-- 	return buttons
-- end

add_printer("/custom-settings", function()
	settings = {
		{ header = "Recommended" },
-- 		{ title = "Automate choice noncombats", set = "character", name = "automate choice noncombats", field = "yesno" },
		{ title = "Allow the kolproxy scripts to download pages (required for everything else)", set = "character", name = "run automation scripts", field = "yesno", default_yes = true, explanation = "This is required for other advanced functionality to work.<br><br>If this is disabled, then only the pages your browser specifically requests will be downloaded from the server. E.g. if you were to click the ascension checklist, it would try to download it from the KoL server and return an error message, instead of letting the script run and load your inventory/storage/closet.<br><br>You probably always want this enabled. If it's disabled, kolproxy scripts are limited to only parsing/changing page text." },
		{ title = "Enable adventuring mistake warnings about semirares, not enough meat, etc.", set = "character", name = "enable adventure warnings", field = "yesno", default_yes = true },
		{ title = "Add many extra warnings for things that are worth thinking about", set = "character", name = "show extra warnings", field = "yesno" },
		{ title = "Use faster custom kolproxy charpane (set compact or normal-mode charpane in KoL options)", set = "character", name = "use custom kolproxy charpane", field = "yesno", default_yes = true },
		{ title = "Show modifier estimates (+noncombat%, +item%, +ML, <b>not always accurate</b>)", set = "character", name = "show modifier estimates", field = "yesno" },
		{ title = "Show monster stat estimates (base HP and item drops, <b>not always accurate</b>)", set = "character", name = "show monster stats", field = "yesno" },
		{ title = "Preview what chat commands will do", set = "character", name = "preview chat commands", field = "yesno" },
		{ title = "Automatically complete simple tasks and puzzles that don't cost turns", set = "character", name = "automate simple tasks", field = "yesno", explanation = "This enables the things kolproxy can do behind the scenes, such as using the plus sign when you get it, solving the strange leaflet when you use it, using evil eyes, etc.<br><br>You probably want this enabled unless there are bugs in the automation code." },
		{ title = "Automate daily visits (rumpus room, garden, etc.)", set = "character", name = "automate daily visits", field = "yesno" },
		{ title = "Enable re-adventuring automation (set a macro as your autoattack, and click the link to spend multiple turns in a row in the same place)", set = "character", name = "enable turn automation", field = "yesno" },
		{ header = "Optional" },
		{ title = "Enable the most recent features that are still being developed", set = "character", name = "enable experimental implementations", field = "yesno", explanation = "Current experimental implementations<br>(functional, but not polished and can contain bugs):<br><ul><li>Mining minigame helper<br>(works, but slows down loading the page)</li><li>Nemesis quest automation</li><li>Suburban Dis quest automation</li><li>Space shield generator quest automation</li></ul>" },
		{ title = "Enable high-skill ascension automation script (for when you already have &#8220;everything&#8221; ascension-relevant and want to automate the entire ascension)", set = "character", name = "enable ascension automation", field = "yesno" },
		{ title = "Use custom super-compact menupane", set = "character", name = "enable super-compact menupane", field = "yesno" },
		{ title = "Ask chatbot for bounty/clover status on logon", set = "character", name = "ask chatbot on logon", field = "yesno" },
-- 		{ title = "Aftercore logout outfit", set = "character", name = "logout outfit", field = "text", example = "Rollover" },
-- 		{ title = "Healing skill ID", set = "ascension", name = "healing skill", field = "number", example = "3012" },
-- 		{ title = "Buffing outfit", set = "ascension", name = "buffing outfit", field = "text", example = "Buffing" },
-- 		{ title = "Buffing outfit (when auto-healing)", set = "ascension", name = "autoheal buffing outfit", field = "text", example = "Buffing" },
	}
	settingstext = ""
	for idx, s in pairs(settings) do
		local this_text = nil
		if s.header then
			this_text = "<h4>" .. s.header .. "</h4>"
		else
			value = get_state(s.set, s.name)
			namestr = "name-" .. tostring(idx)
			valuestr = "value-" .. tostring(idx)
			if s.field == "text" then
	-- 			example = [[(e.g. <i>]] .. s.example .. [[</i>)]]
	-- 			item_text = s.title .. [[ = <input name="]]..valuestr..[[" value="]] .. value .. [[">]] .. example
	-- 		elseif s.field == "number" then
	-- 			example = [[(e.g. <i>]] .. s.example .. [[</i>)]]
	-- 			item_text = s.title .. [[ = <input name="]]..valuestr..[[" value="]] .. value .. [[">]] .. example
			elseif s.field == "yesno" then
				if value == "yes" then
					checkbox_value = [[checked="checked" ]]
				elseif value == "no" then
					checkbox_value = [[]]
				else
					if s.default_yes then
						checkbox_value = [[checked="checked" ]]
					else
						checkbox_value = [[]]
					end
				end
				explanationmark = ""
				explanationtext = ""
				if s.explanation and false then
					explanationmark = [[<sup><b><a class='nounder' href="javascript:toggle('explanation-]]..tostring(idx)..[[')">(?)</a></b></sup>]]
					explanationtext = [[
	<div id='explanation-]]..tostring(idx)..[[' style="display: none"><center><div class="helpbox">]]..s.explanation..[[</div></center></div>]]
				end
				inputelem = [[<input type="checkbox" ]]..checkbox_value..[[name="]]..s.name..[[" id="id]]..s.name..[[" onChange="click_cb(this, ']]..s.name..[[', ']]..s.set..[[')"/>]]
				checkbox = [[<div><label style="padding: 3px" for="id]] .. s.name .. [[">]]..inputelem..s.title..[[</label>]]..explanationmark..[[</div>]]
				item_text = [[<div id="]] .. s.name .. [[" class="opt checkbox">]] .. checkbox .. [[<input type="hidden" class="stateset" value="]] .. s.set .. [[">]]..explanationtext..[[</div>]]
	-- 		elseif s.field == "option" then
	-- 			buttons = make_buttons(valuestr, value, s.values)
	-- 			item_text = s.title .. [[ = ]] .. buttons
	-- 		else
	-- 			item_text = s.title .. [[ = <input name="]]..valuestr..[[" value="]] .. value .. [[">]]
			end
			this_text = [[<p>
			<input type="hidden" name="]]..namestr..[[" value="]] .. s.name .. [[">
			]] .. item_text .. [[
			<input type="hidden" name="stateset-]]..idx..[[" value="]] .. s.set .. [[">
	</p>
	]]
		end
		settingstext = settingstext .. this_text
	end
	text = [[
	<table width=95% cellspacing=0 cellpadding=0 align=center>
		<tr><td style="color: white;" align=center bgcolor=green><b>Kolproxy settings</b></td></tr>
		<tr><td style="padding: 5px; border: 1px solid green;">
			<center><table><tr><td>
				<a href="http://www.houeland.com/kolproxy/wiki/Kolproxy_settings" target="_blank">Help</a> (opens setting documentation in a new tab)<br>
				<form action="custom-settings" method="post">
					]] .. settingstext .. [[
					<input type="hidden" name="pwd" value="]] .. session.pwd .. [["><input type="hidden" name="action" value="set state">
				</form>
			</td></tr></table></center>
		</td></tr>
		<tr><td height=4></td></tr>
	</table>
	<table width=95% cellspacing=0 cellpadding=0 align=center>
		<tr><td style="color: white;" align=center bgcolor=green><b>Kolproxy special pages</b></td></tr>
		<tr><td style="padding: 5px; border: 1px solid green;">
			<center><table><tr><td>
			<tr><td><center><a href="custom-logs?pwd=]]..session.pwd..[[">Parse ascension log</a></center></td></tr>
			<tr><td><center><a href="kolproxy-automation-script?automation-script=custom-mix-drinks&pwd=]]..session.pwd..[[">List advanced cocktails you can craft</a></center></td></tr>
			<tr><td><center><a href="kolproxy-automation-script?automation-script=custom-ascension-checklist&pwd=]]..session.pwd..[[">Pre-ascension pull stocking checklist</a></center></td></tr>
			<tr><td><center><a href="http://www.houeland.com/kolproxy/wiki/" target="_blank">Kolproxy wiki with documentation</a> (opens in a new tab)</center></td></tr>
			</td></tr></table></center>
		</td></tr>
		<tr><td height=4></td></tr>
	</table>
	<table width=95%%  cellspacing=0 cellpadding=0 align=center>
		<tr><td style="color: white;" align=center bgcolor=green><b>Developer tools</b></td></tr>
		<tr><td style="padding: 5px; border: 1px solid green;">
			<center><table><tr><td>
			<tr><td><center><input type="button" value="Reload Lua script files" onclick="javascript:clear_lua_script_cache(this)"></center></td></tr>
			</td></tr></table></center>
		</td></tr>
		<tr><td height=4></td></tr>
	</table>
	]]
-- 	<table  width=95%%  cellspacing=0 cellpadding=0>
-- 		<tr><td style="color: white;" align=center bgcolor=green><b>Server settings</b></td></tr>
-- 		<tr><td style="padding: 5px; border: 1px solid green;">
-- 			<center><table><tr><td>
-- 				<form action="custom-store-settings" method="post">
-- 					<input type="hidden" name="pwd" value="]] .. session.pwd .. [[">
-- 					<input type="submit" value="Store kolproxy settings on server">
-- 				</form>
-- 				<form action="custom-load-settings" method="post">
-- 					<input type="hidden" name="pwd" value="]] .. session.pwd .. [[">
-- 					<input type="submit" value="Load kolproxy settings from server">
-- 				</form>
-- 			<tr><td><center><a href="account.php">Back to Account Menu</a></center></td></tr>
-- 			</td></tr></table></center>
-- 		</td></tr>
-- 		<tr><td height=4></td></tr>
-- 	</table>
-- 	]]
	text = [[
		<html>
		<head>
			<script language="Javascript" src="http://images.kingdomofloathing.com/scripts/core.js"></script>
			<link rel="stylesheet" type="text/css" href="http://images.kingdomofloathing.com/styles.css">
			<style type="text/css">
				.helpbox {
				   width: 500px;
				   border: 1px solid black;
				   padding: 5px;
				}
			</style>
			<script language="Javascript" src="http://images.kingdomofloathing.com/scripts/jquery-1.3.1.min.js"></script>
			<script type="text/javascript">
function click_cb(cb, name, stateset) {
	var cur = "no"
	if (cb.checked) {
		cur = "yes"
	}
	$.post('custom-settings', { pwd:']]..session.pwd..[[', action:'set state', name:name, stateset:stateset, value:cur, ajax: 1 }, function (res) {
		enableDiv(label);
	});
	return true;
}
function clear_lua_script_cache(button) {
	var pwd = ']] .. session.pwd .. [['
	$.post('custom-clear-lua-script-cache', { pwd: pwd }, function (res) {
		button.value = 'Script cache cleared!'
	});
}
			</script>
		</head>
		<body>]] .. text .. [[
		</body>
		</html>]]
--~ 	print("params", params)
end)
